Index: Makefile
===================================================================
--- Makefile	(revision 34061)
+++ Makefile	(working copy)
@@ -710,6 +710,47 @@
 		echo ";astctl = asterisk.ctl" ; \
 		echo ";[options]" ; \
 		echo ";internal_timing = yes" ; \
+		echo ";"; \
+		echo "; The following section allows to choose the translation and the codec"; \
+		echo "; negotiation algorithms"; \
+		echo ";"; \
+		echo "[codec_negotiation]"; \
+		echo ";"; \
+		echo "; The translation_algorithm option allows to choose between two"; \
+		echo "; algorythms:"; \
+		echo ";"; \
+		echo "; 1. Always follow the format of data that the peer sends in."; \
+		echo "; For example suppose the peer announced support for G729 and ULAW and"; \
+		echo "; sends data in G729. Then Asterisk will translate all outgoing frames"; \
+		echo "; to G729 regardless of initial format of the outgoing frames even if"; \
+		echo "; they are in ULAW format. Outgoing G729 frames of course will not be"; \
+		echo "; translated."; \
+		echo ";"; \
+		echo "; The name of this algorithm is:"; \
+		echo ";	strict"; \
+		echo ";"; \
+		echo "; Synonyms are:"; \
+		echo ";	follow_peer"; \
+		echo ";	avoid_asymmetry"; \
+		echo ";"; \
+		echo "; 2. Avoid translations if possible."; \
+		echo "; For example suppose the peer announced support for G729 and ULAW and"; \
+		echo "; sends data in G729. If Asterisk is to send the frame in G729 or ULAW"; \
+		echo "; format then no translation will be performed and so frame is sent"; \
+		echo "; unchanged. If the outgoing frame is in other format (not G729 or ULAW)"; \
+		echo "; then the frame will be translated to G729 format."; \
+		echo ";"; \
+		echo "; The name of the algorithm is:"; \
+		echo ";	loose"; \
+		echo ";"; \
+		echo "; Synonyms are:"; \
+		echo ";	save_cpu"; \
+		echo ";	avoid_translation"; \
+		echo ";	asymmetric"; \
+		echo ";"; \
+		echo "; Default: strict"; \
+		echo ";"; \
+		echo ";translation_algorithm = strict"; \
 		) > $(DESTDIR)$(ASTCONFPATH) ; \
 	else \
 		echo "Skipping asterisk.conf creation"; \
Index: apps/app_chanisavail.c
===================================================================
--- apps/app_chanisavail.c	(revision 34061)
+++ apps/app_chanisavail.c	(working copy)
@@ -122,7 +122,7 @@
 				snprintf(trychan, sizeof(trychan), "%s/%s",cur,number);
 				status = inuse = ast_device_state(trychan);
 			}
-			if ((inuse <= 1) && (tempchan = ast_request(tech, chan->nativeformats, number, &status))) {
+			if ((inuse <= 1) && (tempchan = ast_request(tech, &chan->nativeformats, number, &status))) {
 					pbx_builtin_setvar_helper(chan, "AVAILCHAN", tempchan->name);
 					/* Store the originally used channel too */
 					snprintf(tmp, sizeof(tmp), "%s/%s", tech, number);
Index: apps/app_dial.c
===================================================================
--- apps/app_dial.c	(revision 34061)
+++ apps/app_dial.c	(working copy)
@@ -482,7 +482,7 @@
 					if (option_verbose > 2)
 						ast_verbose(VERBOSE_PREFIX_3 "Now forwarding %s to '%s/%s' (thanks to %s)\n", in->name, tech, stuff, c->name);
 					/* Setup parameters */
-					c = o->chan = ast_request(tech, in->nativeformats, stuff, &cause);
+					c = o->chan = ast_request(tech, &in->nativeformats, stuff, &cause);
 					/* If we have been told to ignore forwards, just set this channel to null and continue processing extensions normally */
 					if (ast_test_flag(peerflags, OPT_IGNORE_FORWARDING)) {
 						if (option_verbose > 2)
@@ -491,7 +491,7 @@
 						cause = AST_CAUSE_BUSY;
 					} else {
 						/* Setup parameters */
-						c = o->chan = ast_request(tech, in->nativeformats, stuff, &cause);
+						c = o->chan = ast_request(tech, &in->nativeformats, stuff, &cause);
 						if (!c)
 							ast_log(LOG_NOTICE, "Unable to create local channel for call forward to '%s/%s' (cause = %d)\n", tech, stuff, cause);
 						else
@@ -1063,7 +1063,7 @@
 		}
 		ast_copy_string(numsubst, number, sizeof(numsubst));
 		/* Request the peer */
-		tmp->chan = ast_request(tech, chan->nativeformats, numsubst, &cause);
+		tmp->chan = ast_request(tech, &chan->nativeformats, numsubst, &cause);
 		if (!tmp->chan) {
 			/* If we can't, just go on to the next call */
 			ast_log(LOG_WARNING, "Unable to create channel of type '%s' (cause %d - %s)\n", tech, cause, ast_cause2str(cause));
@@ -1098,7 +1098,7 @@
 					if (option_verbose > 2)
 						ast_verbose(VERBOSE_PREFIX_3 "Forwarding %s to '%s/%s' prevented.\n", chan->name, tech, stuff);
 				} else {
-					tmp->chan = ast_request(tech, chan->nativeformats, stuff, &cause);
+					tmp->chan = ast_request(tech, &chan->nativeformats, stuff, &cause);
 				}
 				if (!tmp->chan)
 					ast_log(LOG_NOTICE, "Unable to create local channel for call forward to '%s/%s' (cause = %d)\n", tech, stuff, cause);
Index: apps/app_dumpchan.c
===================================================================
--- apps/app_dumpchan.c	(revision 34061)
+++ apps/app_dumpchan.c	(working copy)
@@ -112,7 +112,7 @@
 			 ast_state2str(c->_state),
 			 c->_state,
 			 c->rings,
-			 ast_getformatname_multiple(formatbuf, sizeof(formatbuf), c->nativeformats),
+			 ast_codec_pref_dump(formatbuf, sizeof(formatbuf), &c->nativeformats),
 			 ast_getformatname_multiple(formatbuf, sizeof(formatbuf), c->writeformat),
 			 ast_getformatname_multiple(formatbuf, sizeof(formatbuf), c->readformat),
 			 c->fds[0], c->fin & ~DEBUGCHAN_FLAG, (c->fin & DEBUGCHAN_FLAG) ? " (DEBUGGED)" : "",
Index: apps/app_echo.c
===================================================================
--- apps/app_echo.c	(revision 34061)
+++ apps/app_echo.c	(working copy)
@@ -62,7 +62,7 @@
 
 	LOCAL_USER_ADD(u);
 
-	format = ast_best_codec(chan->nativeformats);
+	format = ast_best_codec(ast_codec_pref_bits(&chan->nativeformats));
 	ast_set_write_format(chan, format);
 	ast_set_read_format(chan, format);
 
Index: apps/app_followme.c
===================================================================
--- apps/app_followme.c	(revision 34061)
+++ apps/app_followme.c	(working copy)
@@ -823,7 +823,7 @@
 				return;
 			}
 					
-			outbound = ast_request("Local", ast_best_codec(caller->nativeformats), dialarg, &dg);
+			outbound = ast_request("Local", &caller->nativeformats, dialarg, &dg);
 			if (outbound) {
 				ast_set_callerid(outbound, caller->cid.cid_num, caller->cid.cid_name, caller->cid.cid_num);
 				ast_channel_inherit_variables(tpargs->chan, outbound);
Index: apps/app_meetme.c
===================================================================
--- apps/app_meetme.c	(revision 34061)
+++ apps/app_meetme.c	(working copy)
@@ -521,6 +521,9 @@
 	if (!cnf && (make || dynamic)) {
 		/* Make a new one */
 		if ((cnf = ast_calloc(1, sizeof(*cnf)))) {
+			struct ast_codec_pref formats;
+			ast_codec_pref_set2(&formats, AST_FORMAT_ULAW);
+
 			ast_mutex_init(&cnf->playlock);
 			ast_mutex_init(&cnf->listenlock);
 			ast_copy_string(cnf->confno, confno, sizeof(cnf->confno));
@@ -528,7 +531,7 @@
 			ast_copy_string(cnf->pinadmin, pinadmin, sizeof(cnf->pinadmin));
 			cnf->refcount = 0;
 			cnf->markedusers = 0;
-			cnf->chan = ast_request("zap", AST_FORMAT_SLINEAR, "pseudo", NULL);
+			cnf->chan = ast_request("zap", &formats, "pseudo", NULL);
 			if (cnf->chan) {
 				ast_set_read_format(cnf->chan, AST_FORMAT_SLINEAR);
 				ast_set_write_format(cnf->chan, AST_FORMAT_SLINEAR);
@@ -558,7 +561,7 @@
 				cnf = NULL;
 				goto cnfout;
 			}
-			cnf->lchan = ast_request("zap", AST_FORMAT_SLINEAR, "pseudo", NULL);
+			cnf->lchan = ast_request("zap", &formats, "pseudo", NULL);
 			if (cnf->lchan) {
 				ast_set_read_format(cnf->lchan, AST_FORMAT_SLINEAR);
 				ast_set_write_format(cnf->lchan, AST_FORMAT_SLINEAR);
Index: apps/app_page.c
===================================================================
--- apps/app_page.c	(revision 34061)
+++ apps/app_page.c	(working copy)
@@ -89,7 +89,10 @@
 static void *page_thread(void *data)
 {
 	struct calloutdata *cd = data;
-	ast_pbx_outgoing_app(cd->tech, AST_FORMAT_SLINEAR, cd->resource, 30000,
+	struct ast_codec_pref slin;
+	ast_codec_pref_init(&slin);
+	ast_codec_pref_append(&slin, AST_FORMAT_SLINEAR);
+	ast_pbx_outgoing_app(cd->tech, &slin, cd->resource, 30000,
 		"MeetMe", cd->meetmeopts, NULL, 0, cd->cidnum, cd->cidname, cd->variables, NULL, NULL);
 	free(cd);
 	return NULL;
Index: apps/app_parkandannounce.c
===================================================================
--- apps/app_parkandannounce.c	(revision 34061)
+++ apps/app_parkandannounce.c	(working copy)
@@ -95,6 +95,11 @@
 
 	struct localuser *u;
 
+	struct ast_codec_pref formats;
+
+	ast_codec_pref_init(&formats);
+	ast_codec_pref_append(&formats, AST_FORMAT_SLINEAR);
+
 	if (ast_strlen_zero(data)) {
 		ast_log(LOG_WARNING, "ParkAndAnnounce requires arguments: (announce:template|timeout|dial|[return_context])\n");
 		return -1;
@@ -194,7 +199,7 @@
 	memset(&oh, 0, sizeof(oh));
 	oh.parent_channel = chan;
 	oh.vars = ast_variable_new("_PARKEDAT", buf);
-	dchan = __ast_request_and_dial(dialtech, AST_FORMAT_SLINEAR, dialstr,30000, &outstate, chan->cid.cid_num, chan->cid.cid_name, &oh);
+	dchan = __ast_request_and_dial(dialtech, &formats, dialstr,30000, &outstate, chan->cid.cid_num, chan->cid.cid_name, &oh);
 
 	if(dchan) {
 		if(dchan->_state == AST_STATE_UP) {
Index: apps/app_queue.c
===================================================================
--- apps/app_queue.c	(revision 34061)
+++ apps/app_queue.c	(working copy)
@@ -1560,7 +1560,7 @@
 		location = "";
 
 	/* Request the peer */
-	tmp->chan = ast_request(tech, qe->chan->nativeformats, location, &status);
+	tmp->chan = ast_request(tech, &qe->chan->nativeformats, location, &status);
 	if (!tmp->chan) {			/* If we can't, just go on to the next call */
 #if 0
 		ast_log(LOG_NOTICE, "Unable to create channel of type '%s' for Queue\n", cur->tech);
@@ -1877,7 +1877,7 @@
 					if (option_verbose > 2)
 						ast_verbose(VERBOSE_PREFIX_3 "Now forwarding %s to '%s/%s' (thanks to %s)\n", in->name, tech, stuff, o->chan->name);
 					/* Setup parameters */
-					o->chan = ast_request(tech, in->nativeformats, stuff, &status);
+					o->chan = ast_request(tech, &in->nativeformats, stuff, &status);
 					if (status != o->oldstatus) 
 						update_dial_status(qe->parent, o->member, status);						
 					if (!o->chan) {
Index: asterisk.c
===================================================================
--- asterisk.c	(revision 34061)
+++ asterisk.c	(working copy)
@@ -166,6 +166,7 @@
 
 char record_cache_dir[AST_CACHE_DIR_LEN] = AST_TMP_DIR;
 char debug_filename[AST_FILENAME_MAX] = "";
+enum ast_trans_algorithm option_translation_algorithm = AST_TRANS_ALG_STRICT;
 
 static int ast_socket = -1;		/*!< UNIX Socket for allowing remote control */
 static int ast_consock = -1;		/*!< UNIX Socket for controlling another asterisk */
@@ -2303,6 +2304,30 @@
 			ast_copy_string(ast_config_AST_SYSTEM_NAME, v->value, sizeof(ast_config_AST_SYSTEM_NAME));
 		} else if (!strcasecmp(v->name, "languageprefix")) {
 			ast_language_is_prefix = ast_true(v->value);
+		}
+	}
+	option_translation_algorithm = AST_TRANS_ALG_STRICT;
+	for (v = ast_variable_browse(cfg, "codec_negotiation"); v; v = v->next)
+	{
+		if (!strcasecmp(v->name, "translation_algorithm")) {
+			if (!strcasecmp(v->value, "loose") ||
+			    !strcasecmp(v->value, "save_cpu") ||
+			    !strcasecmp(v->value, "avoid_translation") ||
+			    !strcasecmp(v->value, "asymmetric"))
+			{
+				option_translation_algorithm = AST_TRANS_ALG_LOOSE;
+			}
+/*
+			else if (!strcasecmp(v->value, "strict") ||
+				 !strcasecmp(v->value, "follow_peer") ||
+				 !strcasecmp(v->value, "avoid_asymmetry"))
+			{
+				option_translation_algorithm = AST_TRANS_ALG_STRICT;
+			}
+*/
+			else {
+				option_translation_algorithm = AST_TRANS_ALG_STRICT;
+			}
 		}
 	}
 	ast_config_destroy(cfg);
Index: channel.c
===================================================================
--- channel.c	(revision 34061)
+++ channel.c	(working copy)
@@ -979,10 +979,7 @@
 		ast_moh_cleanup(chan);
 
 	/* Free translators */
-	if (chan->readtrans)
-		ast_translator_free_path(chan->readtrans);
-	if (chan->writetrans)
-		ast_translator_free_path(chan->writetrans);
+	ast_translator_free_translations(chan);
 	if (chan->pbx)
 		ast_log(LOG_WARNING, "PBX may not have been terminated properly on '%s'\n", chan->name);
 	free_cid(&chan->cid);
@@ -1424,14 +1421,9 @@
 
 static void free_translation(struct ast_channel *clone)
 {
-	if (clone->writetrans)
-		ast_translator_free_path(clone->writetrans);
-	if (clone->readtrans)
-		ast_translator_free_path(clone->readtrans);
-	clone->writetrans = NULL;
-	clone->readtrans = NULL;
-	clone->rawwriteformat = clone->nativeformats;
-	clone->rawreadformat = clone->nativeformats;
+	ast_translator_free_translations(clone);
+	clone->rawwriteformat = clone->nativeformats.audio_bits;
+	clone->rawreadformat = clone->nativeformats.audio_bits;
 }
 
 /*! \brief Hangup a channel */
@@ -2022,11 +2014,12 @@
 			if (dropaudio) {
 				ast_frfree(f);
 				f = &ast_null_frame;
-			} else if (!(f->subclass & chan->nativeformats)) {
+			} else if (!(f->subclass & chan->nativeformats.audio_bits)) {
+				char buf[512];
 				/* This frame can't be from the current native formats -- drop it on the
 				   floor */
 				ast_log(LOG_NOTICE, "Dropping incompatible voice frame on %s of format %s since our native format has changed to %s\n",
-					chan->name, ast_getformatname(f->subclass), ast_getformatname(chan->nativeformats));
+					chan->name, ast_getformatname(f->subclass), ast_codec_pref_dump(buf, sizeof(buf), &chan->nativeformats));
 				ast_frfree(f);
 				f = &ast_null_frame;
 			} else {
@@ -2058,7 +2051,8 @@
 					}
 				}
 
-				if (chan->readtrans && (f = ast_translate(chan->readtrans, f, 1)) == NULL)
+				f = ast_translate_read(chan, f, 1);
+				if (!f)
 					f = &ast_null_frame;
 
 				/* Run generator sitting on the line if timing device not available
@@ -2396,7 +2390,7 @@
 		if (fr->subclass == chan->rawwriteformat)
 			f = fr;
 		else
-			f = (chan->writetrans) ? ast_translate(chan->writetrans, fr, 0) : fr;
+			f = ast_translate_write(chan, fr, 0);
 		if (f == NULL) {
 			res = 0;
 		} else {
@@ -2448,7 +2442,7 @@
 }
 
 static int set_format(struct ast_channel *chan, int fmt, int *rawformat, int *format,
-		      struct ast_trans_pvt **trans, const int direction)
+		      const int direction)
 {
 	int native;
 	int res;
@@ -2456,7 +2450,7 @@
 	/* Make sure we only consider audio */
 	fmt &= AST_FORMAT_AUDIO_MASK;
 	
-	native = chan->nativeformats;
+	native = ast_codec_pref_index_audio(&chan->nativeformats, 0);
 	/* Find a translation path from the native format to one of the desired formats */
 	if (!direction)
 		/* reading */
@@ -2466,26 +2460,19 @@
 		res = ast_translator_best_choice(&native, &fmt);
 
 	if (res < 0) {
+		char buf[512];
 		ast_log(LOG_WARNING, "Unable to find a codec translation path from %s to %s\n",
-			ast_getformatname(native), ast_getformatname(fmt));
+			ast_getformatname_multiple(buf, sizeof(buf), native), ast_getformatname(fmt));
+/*
 		return -1;
+*/
 	}
 	
 	/* Now we have a good choice for both. */
 	ast_channel_lock(chan);
-	*rawformat = native;
+	*rawformat = chan->lastreadformat = native;
 	/* User perspective is fmt */
 	*format = fmt;
-	/* Free any read translation we have right now */
-	if (*trans)
-		ast_translator_free_path(*trans);
-	/* Build a translation path from the raw format to the desired format */
-	if (!direction)
-		/* reading */
-		*trans = ast_translator_build_path(*format, *rawformat);
-	else
-		/* writing */
-		*trans = ast_translator_build_path(*rawformat, *format);
 	ast_channel_unlock(chan);
 	if (option_debug)
 		ast_log(LOG_DEBUG, "Set channel %s to %s format %s\n", chan->name,
@@ -2495,17 +2482,15 @@
 
 int ast_set_read_format(struct ast_channel *chan, int fmt)
 {
-	return set_format(chan, fmt, &chan->rawreadformat, &chan->readformat,
-			  &chan->readtrans, 0);
+	return set_format(chan, fmt, &chan->rawreadformat, &chan->readformat, 0);
 }
 
 int ast_set_write_format(struct ast_channel *chan, int fmt)
 {
-	return set_format(chan, fmt, &chan->rawwriteformat, &chan->writeformat,
-			  &chan->writetrans, 1);
+	return set_format(chan, fmt, &chan->rawwriteformat, &chan->writeformat, 1);
 }
 
-struct ast_channel *__ast_request_and_dial(const char *type, int format, void *data, int timeout, int *outstate, const char *cid_num, const char *cid_name, struct outgoing_helper *oh)
+struct ast_channel *__ast_request_and_dial(const char *type, const struct ast_codec_pref *formats, void *data, int timeout, int *outstate, const char *cid_num, const char *cid_name, struct outgoing_helper *oh)
 {
 	int dummy_outstate;
 	int cause = 0;
@@ -2517,7 +2502,7 @@
 	else
 		outstate = &dummy_outstate;	/* make outstate always a valid pointer */
 
-	chan = ast_request(type, format, data, &cause);
+	chan = ast_request(type, formats, data, &cause);
 	if (!chan) {
 		ast_log(LOG_NOTICE, "Unable to request channel %s/%s\n", type, (char *)data);
 		/* compute error and return */
@@ -2620,21 +2605,20 @@
 	return chan;
 }
 
-struct ast_channel *ast_request_and_dial(const char *type, int format, void *data, int timeout, int *outstate, const char *cidnum, const char *cidname)
+struct ast_channel *ast_request_and_dial(const char *type, const struct ast_codec_pref *formats, void *data, int timeout, int *outstate, const char *cidnum, const char *cidname)
 {
-	return __ast_request_and_dial(type, format, data, timeout, outstate, cidnum, cidname, NULL);
+	return __ast_request_and_dial(type, formats, data, timeout, outstate, cidnum, cidname, NULL);
 }
 
-struct ast_channel *ast_request(const char *type, int format, void *data, int *cause)
+struct ast_channel *ast_request(const char *type, const struct ast_codec_pref *requested_formats, void *data, int *cause)
 {
 	struct chanlist *chan;
 	struct ast_channel *c;
-	int capabilities;
-	int fmt;
-	int res;
 	int foo;
-	int videoformat = format & AST_FORMAT_VIDEO_MASK;
+	struct ast_codec_pref formats;
 
+	memcpy(&formats, requested_formats, sizeof(formats));
+	ast_codec_pref_append_missing2(&formats, ast_compatible_audio_formats(formats.audio_bits));
 	if (!cause)
 		cause = &foo;
 	*cause = AST_CAUSE_NOTDEFINED;
@@ -2645,22 +2629,25 @@
 	}
 
 	AST_LIST_TRAVERSE(&backends, chan, list) {
+		struct ast_codec_pref tmp_formats;
 		if (strcasecmp(type, chan->tech->type))
 			continue;
 
-		capabilities = chan->tech->capabilities;
-		fmt = format & AST_FORMAT_AUDIO_MASK;
-		res = ast_translator_best_choice(&fmt, &capabilities);
-		if (res < 0) {
-			ast_log(LOG_WARNING, "No translator path exists for channel type %s (native %d) to %d\n", type, chan->tech->capabilities, format);
+		if (!(chan->tech->capabilities & ast_codec_pref_bits(&formats)))
+	       	{
+			char buf[512];
+			ast_log(LOG_WARNING, "Channel %s does not support requested formats %s\n", type, ast_codec_pref_dump(buf, sizeof(buf), &formats));
 			AST_LIST_UNLOCK(&channels);
 			return NULL;
 		}
 		AST_LIST_UNLOCK(&channels);
-		if (!chan->tech->requester)
+		if (!chan->tech->requester) {
+			ast_log(LOG_WARNING, "Cannot allocate channel %s because it hasn't registered the requester function\n", type);
 			return NULL;
-		
-		if (!(c = chan->tech->requester(type, capabilities | videoformat, data, cause)))
+		}
+		memcpy(&tmp_formats, &formats, sizeof(formats));
+		ast_codec_pref_remove2(&tmp_formats, ~chan->tech->capabilities);
+		if (!(c = chan->tech->requester(type, &tmp_formats, data, cause)))
 			return NULL;
 
 		if (c->_state == AST_STATE_DOWN) {
@@ -2796,15 +2783,31 @@
 {
 	int src;
 	int dst;
+	int res = -1;
+	int i, j, done;
 
 	/* Set up translation from the chan to the peer */
-	src = chan->nativeformats;
-	dst = peer->nativeformats;
-	if (ast_translator_best_choice(&dst, &src) < 0) {
-		ast_log(LOG_WARNING, "No path to translate from %s(%d) to %s(%d)\n", chan->name, src, peer->name, dst);
+	done = 0;
+	for (i = 0; i < 32 && !done; ++i) {
+		dst = ast_codec_pref_index_audio(&peer->nativeformats, i);
+		if (!dst) break;
+		for (j = 0; j < 32 && !done; ++j) {
+			src = ast_codec_pref_index_audio(&chan->nativeformats, j);
+			if (!src) break;
+			res = ast_translator_best_choice(&dst, &src);
+			if (res >= 0)
+				done = 1;
+		}
+	}
+	if (res < 0) {
+		char buf[512], buf2[512];
+		ast_log(LOG_WARNING, "No path to translate from %s %s to %s %s\n",
+			chan->name,
+			ast_codec_pref_dump(buf, sizeof(buf), &chan->nativeformats),
+			peer->name,
+			ast_codec_pref_dump(buf2, sizeof(buf2), &peer->nativeformats));
 		return -1;
 	}
-
 	/* if the best path is not 'pass through', then
 	   transcoding is needed; if desired, force transcode path
 	   to use SLINEAR between channels, but only if there is
@@ -2822,10 +2825,25 @@
 	}
 
 	/* Set up translation from the peer to the chan */
-	src = peer->nativeformats;
-	dst = chan->nativeformats;
-	if (ast_translator_best_choice(&dst, &src) < 0) {
-		ast_log(LOG_WARNING, "No path to translate from %s(%d) to %s(%d)\n", peer->name, src, chan->name, dst);
+	done = 0;
+	for (i = 0; i < 32 && !done; ++i) {
+		dst = ast_codec_pref_index_audio(&peer->nativeformats, i);
+		if (!dst) break;
+		for (j = 0; j < 32 && !done; ++j) {
+			src = ast_codec_pref_index_audio(&chan->nativeformats, j);
+			if (!src) break;
+			res = ast_translator_best_choice(&src, &dst);
+			if (res >= 0)
+				done = 1;
+		}
+	}
+	if (res < 0) {
+		char buf[512], buf2[512];
+		ast_log(LOG_WARNING, "No path to translate from %s %s to %s %s\n",
+			peer->name,
+			ast_codec_pref_dump(buf2, sizeof(buf2), &peer->nativeformats),
+			chan->name,
+			ast_codec_pref_dump(buf, sizeof(buf), &chan->nativeformats));
 		return -1;
 	}
 
@@ -3157,7 +3175,7 @@
 	original->fds[AST_TIMING_FD] = original->timingfd;
 	
 	/* Our native formats are different now */
-	original->nativeformats = clone->nativeformats;
+	memcpy(&original->nativeformats, &clone->nativeformats, sizeof(struct ast_codec_pref));
 	
 	/* Context, extension, priority, app data, jump table,  remain the same */
 	/* pvt switches.  pbx stays the same, as does next */
@@ -3345,8 +3363,8 @@
 	cs[1] = c1;
 	pvt0 = c0->tech_pvt;
 	pvt1 = c1->tech_pvt;
-	o0nativeformats = c0->nativeformats;
-	o1nativeformats = c1->nativeformats;
+	o0nativeformats = ast_codec_pref_bits(&c0->nativeformats);
+	o1nativeformats = ast_codec_pref_bits(&c1->nativeformats);
 	watch_c0_dtmf = config->flags & AST_BRIDGE_DTMF_CHANNEL_0;
 	watch_c1_dtmf = config->flags & AST_BRIDGE_DTMF_CHANNEL_1;
 
@@ -3357,8 +3375,9 @@
 		struct ast_channel *who, *other;
 
 		if ((c0->tech_pvt != pvt0) || (c1->tech_pvt != pvt1) ||
-		    (o0nativeformats != c0->nativeformats) ||
-		    (o1nativeformats != c1->nativeformats)) {
+		    (o0nativeformats != ast_codec_pref_bits(&c0->nativeformats)) ||
+		    (o1nativeformats != ast_codec_pref_bits(&c1->nativeformats)))
+		{
 			/* Check for Masquerade, codec changes, etc */
 			res = AST_BRIDGE_RETRY;
 			break;
@@ -3521,8 +3540,8 @@
 		      "CallerID2: %s\r\n",
 		      c0->name, c1->name, c0->uniqueid, c1->uniqueid, c0->cid.cid_num, c1->cid.cid_num);
 
-	o0nativeformats = c0->nativeformats;
-	o1nativeformats = c1->nativeformats;
+	o1nativeformats = ast_codec_pref_bits(&c1->nativeformats);
+	o0nativeformats = ast_codec_pref_bits(&c0->nativeformats);
 
 	if (config->timelimit) {
 		nexteventts = ast_tvadd(config->start_time, ast_samp2tv(config->timelimit, 1000));
@@ -3645,7 +3664,8 @@
 		}
 	
 		if (((c0->writeformat != c1->readformat) || (c0->readformat != c1->writeformat) ||
-		    (c0->nativeformats != o0nativeformats) || (c1->nativeformats != o1nativeformats)) &&
+		    (ast_codec_pref_bits(&c0->nativeformats) != o0nativeformats) ||
+		    (ast_codec_pref_bits(&c1->nativeformats) != o1nativeformats)) &&
 		    !(c0->generator || c1->generator)) {
 			if (ast_channel_make_compatible(c0, c1)) {
 				ast_log(LOG_WARNING, "Can't make %s and %s compatible\n", c0->name, c1->name);
@@ -3660,8 +3680,8 @@
 					      c0->name, c1->name, c0->uniqueid, c1->uniqueid, c0->cid.cid_num, c1->cid.cid_num);
 				return AST_BRIDGE_FAILED;
 			}
-			o0nativeformats = c0->nativeformats;
-			o1nativeformats = c1->nativeformats;
+			o0nativeformats = ast_codec_pref_bits(&c0->nativeformats);
+			o1nativeformats = ast_codec_pref_bits(&c1->nativeformats);
 		}
 		res = ast_generic_bridge(c0, c1, config, fo, rc, nexteventts);
 		if (res != AST_BRIDGE_RETRY)
Index: channels/chan_agent.c
===================================================================
--- channels/chan_agent.c	(revision 34061)
+++ channels/chan_agent.c	(working copy)
@@ -207,10 +207,10 @@
 
 #define CHECK_FORMATS(ast, p) do { \
 	if (p->chan) {\
-		if (ast->nativeformats != p->chan->nativeformats) { \
-			ast_log(LOG_DEBUG, "Native formats changing from %d to %d\n", ast->nativeformats, p->chan->nativeformats); \
+		if (!ast_codec_pref_eq_noorder(&ast->nativeformats, &p->chan->nativeformats)) { \
+			ast_log(LOG_DEBUG, "Native formats changing from %d to %d\n", ast_codec_pref_bits(&ast->nativeformats), ast_codec_pref_bits(&p->chan->nativeformats)); \
 			/* Native formats changed, reset things */ \
-			ast->nativeformats = p->chan->nativeformats; \
+			memcpy(&ast->nativeformats, &p->chan->nativeformats, sizeof(ast->nativeformats)); \
 			ast_log(LOG_DEBUG, "Resetting read to %d and write to %d\n", ast->readformat, ast->writeformat);\
 			ast_set_read_format(ast, ast->readformat); \
 			ast_set_write_format(ast, ast->writeformat); \
@@ -237,7 +237,7 @@
 	} \
 } while(0)
 
-static struct ast_channel *agent_request(const char *type, int format, void *data, int *cause);
+static struct ast_channel *agent_request(const char *type, const struct ast_codec_pref *format, void *data, int *cause);
 static int agent_devicestate(void *data);
 static void agent_logoff_maintenance(struct agent_pvt *p, char *loginchan, long logintime, const char *uniqueid, char *logcommand);
 static int agent_digit(struct ast_channel *ast, char digit);
@@ -657,20 +657,20 @@
 		ast_log( LOG_DEBUG, "Waited for stream, result '%d'\n", res);
 	}
 	if (!res) {
-		res = ast_set_read_format(p->chan, ast_best_codec(p->chan->nativeformats));
+		res = ast_set_read_format(p->chan, ast_best_codec(p->chan->nativeformats.audio_bits));
 		ast_log( LOG_DEBUG, "Set read format, result '%d'\n", res);
 		if (res)
-			ast_log(LOG_WARNING, "Unable to set read format to %s\n", ast_getformatname(ast_best_codec(p->chan->nativeformats)));
+			ast_log(LOG_WARNING, "Unable to set read format to %s\n", ast_getformatname(ast_best_codec(p->chan->nativeformats.audio_bits)));
 	} else {
 		/* Agent hung-up */
 		p->chan = NULL;
 	}
 
 	if (!res) {
-		ast_set_write_format(p->chan, ast_best_codec(p->chan->nativeformats));
+		ast_set_write_format(p->chan, ast_best_codec(p->chan->nativeformats.audio_bits));
 		ast_log( LOG_DEBUG, "Set write format, result '%d'\n", res);
 		if (res)
-			ast_log(LOG_WARNING, "Unable to set write format to %s\n", ast_getformatname(ast_best_codec(p->chan->nativeformats)));
+			ast_log(LOG_WARNING, "Unable to set write format to %s\n", ast_getformatname(ast_best_codec(p->chan->nativeformats.audio_bits)));
 	}
 	if( !res )
 	{
@@ -912,7 +912,7 @@
 			ast_copy_string(tmp->context, p->chan->context, sizeof(tmp->context));
 			ast_copy_string(tmp->exten, p->chan->exten, sizeof(tmp->exten));
 		} else {
-			tmp->nativeformats = AST_FORMAT_SLINEAR;
+			ast_codec_pref_append(&tmp->nativeformats, AST_FORMAT_SLINEAR);
 			tmp->writeformat = AST_FORMAT_SLINEAR;
 			tmp->rawwriteformat = AST_FORMAT_SLINEAR;
 			tmp->readformat = AST_FORMAT_SLINEAR;
@@ -1236,7 +1236,7 @@
 }
 
 /*! \brief Part of the Asterisk PBX interface ---*/
-static struct ast_channel *agent_request(const char *type, int format, void *data, int *cause)
+static struct ast_channel *agent_request(const char *type, const struct ast_codec_pref *formats, void *data, int *cause)
 {
 	struct agent_pvt *p;
 	struct ast_channel *chan = NULL;
@@ -1297,7 +1297,7 @@
 						chan = agent_new(p, AST_STATE_DOWN);
 					} else if (!p->owner && !ast_strlen_zero(p->loginchan)) {
 						/* Adjustable agent */
-						p->chan = ast_request("Local", format, p->loginchan, cause);
+						p->chan = ast_request("Local", formats, p->loginchan, cause);
 						if (p->chan)
 							chan = agent_new(p, AST_STATE_DOWN);
 					}
@@ -1946,14 +1946,14 @@
 					AST_LIST_LOCK(&agents);
 					ast_mutex_lock(&p->lock);
 					if (!res) {
-						res = ast_set_read_format(chan, ast_best_codec(chan->nativeformats));
+						res = ast_set_read_format(chan, ast_best_codec(chan->nativeformats.audio_bits));
 						if (res)
-							ast_log(LOG_WARNING, "Unable to set read format to %d\n", ast_best_codec(chan->nativeformats));
+							ast_log(LOG_WARNING, "Unable to set read format to %d\n", ast_best_codec(chan->nativeformats.audio_bits));
 					}
 					if (!res) {
-						res = ast_set_write_format(chan, ast_best_codec(chan->nativeformats));
+						res = ast_set_write_format(chan, ast_best_codec(chan->nativeformats.audio_bits));
 						if (res)
-							ast_log(LOG_WARNING, "Unable to set write format to %d\n", ast_best_codec(chan->nativeformats));
+							ast_log(LOG_WARNING, "Unable to set write format to %d\n", ast_best_codec(chan->nativeformats.audio_bits));
 					}
 					/* Check once more just in case */
 					if (p->chan)
Index: channels/chan_alsa.c
===================================================================
--- channels/chan_alsa.c	(revision 34061)
+++ channels/chan_alsa.c	(working copy)
@@ -800,7 +800,7 @@
 		tmp->tech = &alsa_tech;
 		ast_string_field_build(tmp, name, "ALSA/%s", indevname);
 		tmp->fds[0] = readdev;
-		tmp->nativeformats = AST_FORMAT_SLINEAR;
+		ast_codec_pref_set2(&tmp->nativeformats, AST_FORMAT_SLINEAR);
 		tmp->readformat = AST_FORMAT_SLINEAR;
 		tmp->writeformat = AST_FORMAT_SLINEAR;
 		tmp->tech_pvt = p;
